def nqueens_all_sol(i, free_rows, free_pdiags,
                    free_sdiags, sol):
    n = len(sol)

    # Проверка, является ли частичное решение полным
    if i == n:
        print_chessboard(sol)  # вывод решения
    else:

        # Генерация всех возможных вариантов,
        # которые могут бы быть представлены в частичном решении
        for k in range(0, n):

            # Проверка, является ли
            # k-е решение валидным
            if (free_rows[k] and free_pdiags[i - k + n - 1]
                    and free_sdiags[i + k]):

                # Помещение k-го кандидата в частичное решение
                sol[i] = k

                # Обновление структур данных, указывающее,
                # что k-й кандидат в частичном решении
                free_rows[k] = False
                free_pdiags[i - k + n - 1] = False
                free_sdiags[i + k] = False

                # Рекурсивный вызов, чтобы включить
                # больше кандидатов в частичное решение
                nqueens_all_sol(i + 1, free_rows, free_pdiags,
                                free_sdiags, sol)

                # Исключение k-го кандидата из частичного
                # решения, и восстановление структур данных с
                # указанием того, что k-го кандидата больше
                # нет в частичном решении
                free_rows[k] = True
                free_pdiags[i - k + n - 1] = True
                free_sdiags[i + k] = True


def nqueens_wrapper(n):
    free_rows = [True] * n
    free_pdiags = [True] * (2 * n - 1)
    free_sdiags = [True] * (2 * n - 1)
    sol = [None] * n
    nqueens_all_sol(0, free_rows, free_pdiags, free_sdiags, sol)


def print_chessboard(sol):
    for i in range(0, len(sol)):
        print(sol[i], ' ', end='')
    print()


nqueens_wrapper(8)
